<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/paper-button/paper-button.html">
<link rel="import" href="../bower_components/paper-input/paper-input.html">
<link rel="import" href="../bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="shared-styles.html">

<dom-module id="login-page">
  <template>
    <style include="shared-styles">
      :host {
        display: block;

        padding: 10px;
      }
      .card{
               width: 40%;
    margin: 30px auto;
      }
      paper-button.indigo {
    background-color: var(--paper-indigo-500);
    color: white;
    --paper-button-raised-keyboard-focus: {
      background-color: var(--paper-pink-a200) !important;
      color: white !important;
    };
  }
  paper-button.indigo:hover {
    background-color: var(--paper-indigo-400);
  }
    </style>
     <iron-ajax id="userIdSubmit"
      handle-as"json"
      debounce-duration="300"
      on-response="_handleResponse"></iron-ajax>
    <div class="card">
        <h1>Hello! Welcome to the Payment platform</h1>
        <div>
        <paper-input 
            id="username"
            name="username" 
            label="UserId" 
            value="{{username}}" 
            required 
            auto-validate 
            error-message="UserId is required !">
        </paper-input>
        </div>
        <div style="margin-top:40px;">
        <paper-button raised class="indigo" on-tap="_transactionList" disabled="[[isDisabled]]">Transaction List</paper-button>
        </div>
    </div>
  </template>

  <script>
    class Login extends Polymer.Element {
      static get is() { return 'login-page'; }
      static get properties() {
        return {
          username:{
            type: String
          },
          isDisabled:{ 
            type: Boolean, 
            value:true
          }
        }
      }
      static get observers(){
        return ['_detectChange(username, password)'];
      }

      _detectChange(username){
        var checkName = false;
        if(username) {
          checkName = username.length === 0 ? false : true;
        }
        
        this.isDisabled = !(checkName);
      }

      _transactionList(){
         var ajax = this.$.userIdSubmit;
                  ajax.url="http://10.117.189.180:8080/payment/taxhistory";
                  ajax.generateRequest();
      }
      _handleResponse(response){
          this.transactionData=response.detail.response;
          var obj={
              "userName":this.username,
              "trData":this.transactionData
          }
          localStorage.setItem("transactionData",JSON.stringify(obj));
          window.location.href='/transactions';
      }
    }

    window.customElements.define(Login.is, Login);
  </script>
</dom-module>
